/*
 * Copyright (C) 2025
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "robotmanager.h"
#include "linearrobot.h"
#include "diagonalrobot.h"
#include <iostream>

int main() {
    RobotManager manager;
    manager.add_LinearRobot("W1", 0, 0);
    manager.add_DiagonalRobot("T1", 10, 10);
    manager.add_LinearRobot("W2", -5, 2);

    std::cout << "== ESTADO INICIAL ==" << std::endl;
    manager.show_all();

    manager.move_all(2, -2);

    std::cout << "\n== ESTADO TRAS MOVER ==" << std::endl;
    manager.show_all();

    //-------------------------------------

    std::cout << "-------------------------------------" << std::endl;
    try
    {
        /*Se intenta crear un robot de tipo LinearRobot 
        pero al tener la cadena vacía en el primer parámetro
        salta la excepción std::exception() y se captura en catch.*/
        LinearRobot r("", 0, 0); 
        std::cout << r << std::endl;
    }
    catch(const std::exception& e)
    {
        std::cout << "Se ha capturado la excepción al intentar crear un LinearRobot" << std::endl;
    }
    
    return 0;
}
