/*
 * Copyright (C) 2025
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "intbox.h"
#include <stdexcept>

namespace C3
{
	IntBox::IntBox() : count(0) {}

	void IntBox::add(int16_t value) {
		if (count >= 100) throw std::runtime_error("Box is full");
		data[count++] = value;
	}

	int16_t IntBox::get(uint32_t index) const {
		if (index >= count) throw std::out_of_range("Invalid index");
		return data[index];
	}

	uint32_t IntBox::size() const {
		return count;
	}

}
