/*
 * Copyright (C) 2025
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __INTBOX_H__
#define __INTBOX_H__

#include <cstdint>

namespace C3
{
	class IntBox {
		public:
			IntBox();
			void add(int16_t value);
			int16_t get(uint32_t index) const;
			uint32_t size() const;

		private:
			int16_t data[100];
			uint32_t count;
	};
}
#endif /*__INTBOX_H__*/
