/*
 * Copyright (C) 2025
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <iostream>
#include "box.h"
#include "intbox.h"

using namespace C3;
using namespace std;

int main()
{
	//************************************
	// Ejemplo de uso de IntBox...
	//************************************
    std::cout << "**** IntBox ****" << std::endl;
    IntBox values;
    values.add(10);
    values.add(5);
    std::cout << "Tamaño: " << values.size() << std::endl;
    std::cout << "Elemento 1: " << values.get(1) << std::endl;

    std:cout << endl;
    
	//************************************
	// Ejemplo de uso de Box genérico...
	//************************************
	std::cout << "**** BOX ****" << std::endl;
    Box<std::string, 10> words;
    words.add("hola");
    words.add("mundo");

    std::cout << "Tamaño: " << words.size() << std::endl;
    std::cout << "Elemento 1: " << words.get(1) << std::endl;

    try
    {
        words.get(4); //No existe esta posición y esté método lanza una excepción.
    }
    catch(const std::exception& e)
    {
        std::cout << "No existe la posición accedida en la caja" << std::endl;
    }
    
    return 0;
}
